"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_forge_1 = __importDefault(require("node-forge"));
const react_native_modpow_1 = __importDefault(require("react-native-modpow"));
const sscrypto = __importStar(require("sscrypto/forge"));
const react_native_randombytes_1 = require("react-native-randombytes");
// native-modpow to accelerate RSA encryption
node_forge_1.default.jsbn.BigInteger.prototype.modPow = function nativeModPow(e, m) {
    const result = (0, react_native_modpow_1.default)({
        target: this.toString(16),
        value: e.toString(16),
        modifier: m.toString(16)
    });
    return new node_forge_1.default.jsbn.BigInteger(result, 16);
};
// native random for proper cryptographic-safe sym key generation
sscrypto.SymKey.randomBytesSync_ = function (size) {
    return (0, react_native_randombytes_1.randomBytes)(size);
};
sscrypto.SymKey.randomBytesAsync_ = function (size) {
    return new Promise((resolve, reject) => {
        (0, react_native_randombytes_1.randomBytes)(size, (err, bytes) => {
            if (err)
                reject(err);
            else
                resolve(bytes);
        });
    });
};
// @ts-ignore : we are monkey patching and TS does not like it
sscrypto.utils.randomBytes = function (size) {
    return (0, react_native_randombytes_1.randomBytes)(size);
};
// @ts-ignore : we are monkey patching and TS does not like it
sscrypto.utils.randomBytesAsync = function (size) {
    return new Promise((resolve, reject) => {
        (0, react_native_randombytes_1.randomBytes)(size, (err, bytes) => {
            if (err)
                reject(err);
            else
                resolve(bytes);
        });
    });
};
// necessary for joi, through https://github.com/sideway/address
global.TextEncoder = class TextEncoder {
    constructor() {
        this.encoding = 'utf-8';
    }
    encode(s) {
        return Buffer.from(s, 'utf-8'); // buffer is a subclass of UInt8Array
    }
    encodeInto(s, uint8Array) {
        throw new Error('Not implemented');
    }
};
//# sourceMappingURL=patches.js.map